{ Program Eight utilizes the average cost criterion. The model is control }
{ of the continuous time M / M / K queue with dynamic service pool and }
{ linear holding costs. Servers can be turned off or on. There is both a cost }
{ for changing the pool size and for running the system with a given pool size. }
{ The benchmark policy maintains that constant pool size minimizing the average }
{ cost among constant pool sizes. The optimal policy exhibits hysteresis. }

 
 

program QueueWithAdjustableServicePool (input, output);

 

{Section 10.5}

{Customers arrive to a single queue according to a Poisson process with rate lambda.}

{There are K available servers.}

{The controller has the option of turning servers on or off when a service has been completed or when a new customer arrives.
}

{Each server serves at exponential rate mu. We must have lambda < K mu.}

{There are holding and service cost rates and a one-time charge for changing the number turned on.}

{The excess probability is sent to state N . }

{Because the print out is organized in 4 columns, we must choose N+1 divisible by 4.}

 

const

SIZE = 3;

N = 23;

 

type

RealList = array[0..SIZE] of double;

RealLista = array[0..N, 0..SIZE] of double;

IntList = array[0..N, 0..SIZE] of integer;

 

var

MAX, R, I: integer;

lambda, mu, H, D, tau, arr, ser, Old, epsilon, delta: double;

Cost: RealList;

Fun, WFun: RealLista;

OptAct: IntList;

fpout: TEXT;

file_name: string[80];

 

procedure FillCost;

{This creates the array of cost rates.}

{It is natural to assume that c(k) is increasing in k and that c(0) = 0, but this is not required . }

 

var

k: integer;

begin

writeln('Please enter', SIZE + 1 : 2, ' nonnegative service rate costs.');

writeln('Usually the first cost rate is 0 and the cost rates are increasing . ');

for k := 0 to SIZE do

begin

read(Cost[k]);

writeln(fpout, Cost[k] : 15 : 6);

end;

end;

 

procedure InitialFun;

{This fills the Fun array with zeros. The Fun array corresponds to u.}

 

var

i, k: integer;

begin

for i := 0 to N do

for k := 0 to SIZE do

begin

Fun[i, k] := 0;

end;

end;

 

procedure CreateWFun;

{This creates the WFun array. This is the w array.}

 

var

i, k, j, aux, bux, num: integer;

Temp, TempNew: double;

begin

for i := 0 to N do

begin

aux := i + 1;

if i = N then

begin

aux := N;

end;

bux := i - 1;

if i = 0 then

begin

bux := 0;

end;

for k := 0 to SIZE do

begin

Temp := Cost[0] + D * k * lambda + arr * Fun[aux, 0] + (1 - arr) * Fun[i, k];

OptAct[i, k] := 0;

for j := 1 to SIZE do

begin

if (j < i) or (j = i) then

begin

num := j;

end;

if i < j then

begin

num := i;

end;

TempNew := Cost[j] + D * abs(j - k) * (lambda + mu * num) + arr * Fun[aux, j] + num * ser * Fun[bux, j] + (1 - arr - num *
ser) * Fun[i, k];

if TempNew < Temp then

begin

OptAct[i, k] := j;

Temp := TempNew;

end;

end;

WFun[i, k] := H * i + Temp;

end;

end;

end;

 

procedure UpdateFun;

 

var

i, k: integer;

begin

for i := 0 to N do

for k := 0 to SIZE do

begin

Fun[i, k] := WFun[i, k] - WFun[0, SIZE];

end;

end;

 

procedure WriteOptAct;

 

var

g, k: integer;

begin

writeln('The optimal policy will be specified as follows');

writeln(fpout, 'The optimal policy will be specified as follows');

writeln('The number of servers presently turned on is given.');

writeln(fpout, 'The number of servers presently turned on is given.');

writeln('Then each buffer occupancy is followed by the optimal action, i.e. no. of servers to have on.');

writeln(fpout, 'Then each buffer occupancy is followed by the optimal action , i . e . no . of servers to have on .');

writeln;

writeln(fpout);

for k := 0 to SIZE do

begin

writeln('The number of servers presently turned on is', k : R);

writeln(fpout, 'The number of servers presently turned on is', k : R);

for g := 0 to ((N + 1) div 4) - 1 do

begin

writeln('St', 4 * g : R, ' No' : R, OptAct[4 * g, k] : R, 'St' : R, 4 * g + 1 : R, ' No' : R, OptAct[4 * g + 1, k] : R, 'St ' : R, 4 * g
+ 2 : R, ' No ' : R, OptAct[4 * g + 2, k] : R, ' St ' : R, 4 * g + 3 : R, ' No ' : R, OptAct[4 * g + 3, k] : R);

writeln(fpout, 'St', 4 * g : R, ' No' : R, OptAct[4 * g, k] : R, 'St' : R, 4 * g + 1 : R, ' No' : R, OptAct[4 * g + 1, k] : R, 'St ' : R,
4 * g + 2 : R, ' No ' : R, OptAct[4 * g + 2, k] : R, ' St ' : R, 4 * g + 3 : R, ' No ' : R, OptAct[4 * g + 3, k] : R);

end;

end;

end;

 

{Here is the main program.}

 

begin

writeln('Enter the run name.');

readln(file_name);

rewrite(fpout, file_name);

writeln(fpout, file_name);

 

writeln;

writeln(fpout);

 

writeln('The approximation level is', N);

writeln(fpout, 'The approximation level is', N);

 

writeln('The number of servers is', SIZE);

writeln(fpout, 'The number of servers is', SIZE);

 

writeln('Enter the positive customer arrival rate.');

readln(lambda);

writeln(fpout, 'The customer arrival rate is', lambda : 15 : 8);

 

writeln('Enter the positive customer service rate.');

readln(mu);

writeln(fpout, 'The customer service rate is', mu : 15 : 8);

 

writeln('Enter the positive holding cost coefficient.');

readln(H);

writeln(fpout, 'The holding cost coefficient is', H : 15 : 8);

 

writeln('Enter the nonnegative change coefficient.');

readln(D);

writeln(fpout, 'The change coefficient is', D : 15 : 8);

 

writeln('Enter the tolerance. This is a small positive number.');

readln(epsilon);

writeln(fpout, 'The tolerance level is', epsilon);

 

writeln('Enter the maximum number of iterations allowed.');

readln(MAX);

writeln(fpout, 'The maximum number of iterations allowed is', MAX);

 

writeln;

writeln(fpout);

 

tau := 0.5 * (1 / (lambda + SIZE * mu));

arr := tau * lambda;

ser := tau * mu;

 

FillCost;

InitialFun;

Old := 5;

delta := 1;

I := 1;

R := 5;

 

 

while (delta > epsilon) and (I < MAX) do

begin

CreateWFun;

delta := abs(WFun[0, SIZE] - Old);

Old := WFun[0, SIZE];

UpdateFun;

I := I + 1;

end; {while}

 

writeln('The number of iterations is: ', I);

writeln(fpout, 'The number of iterations is: ', I);

 

writeln('The value of delta is: ', delta : 15 : 10);

writeln(fpout, 'The value of delta is: ', delta : 15 : 10);

 

writeln('The approximate average cost is:', WFun[0, SIZE] : 15 : 6);

writeln(fpout, 'The approximate average cost is:', WFun[0, SIZE] : 15 : 6);

 

writeln;

writeln(fpout);

 

WriteOptAct; {modified to also output to file}

close(fpout);

 

end.
