{ Program Nine utilizes the average cost criterion. The model is control }
{ of the server movement of a three station cyclic polling system. }
{ Arrivals to each station occur according to a Poisson process. }
{ The service time of a customer is exponential and the walking times }
{ are exponential, with no setups. There are linear holding costs and }
{ costs for walking. The benchmark policy is exhaustive service. }
 

 


 

program AverageCostPollingSystem (input, output);

 

{Section 10.6}

{This is a cyclic polling system with 3 stations, Poisson arrivals, and exponential services and walking times.}

{The arrival and service rates must satisfy the stability condition.}

{The excess probability is sent to state N . }

 

const

N = 5;

 

type

RealListOne = array[1..3] of double;

RealListTwo = array[0..N, 0..N, 0..N, 1..3] of double;

IntList = array[0..N, 0..N, 0..N, 1..3] of integer;

 

var

MAX, S, I: integer;

lambda, mu, omega, arr, ser, walk, HRate, WCost: RealListOne;

totarr, phi, tau, epsilon, Old, delta: double;

Fun, Sun, WFun, WSun: RealListTwo;

OptAct: IntList;

fpout: TEXT;

file_name: string[80];

 

procedure ArrivalRates;

 

var

i: integer;

begin

writeln('Enter the customer arrival rate for each of the stations, beginning with station 1.');

writeln(fpout, 'Enter the customer arrival rate for each of the stations, beginning with station 1.');

for i := 1 to 3 do

begin

read(lambda[i]);

writeln(fpout, lambda[i] : 15 : 6);

end;

end;

 

procedure ServiceRates;

 

var

i: integer;

begin

writeln('Enter the service rate for each of the stations, beginning with station 1.');

writeln('Be sure that the stability condition is satisfied.');

writeln(fpout, 'Enter the service rate for each of the stations, beginning with station 1.');

for i := 1 to 3 do

begin

read(mu[i]);

writeln(fpout, mu[i] : 15 : 6);

end;

end;

 

procedure WalkingRates;

 

var

i: integer;

begin

writeln('Enter the walking rate for each of the stations, beginning with station 1.');

writeln(fpout, 'Enter the walking rate for each of the stations, beginning with station 1.');

for i := 1 to 3 do

begin

read(omega[i]);

writeln(fpout, omega[i] : 15 : 6);

end;

end;

 

procedure CreateQuantities;

{This creates arrays that are tau times the original ones.}

 

var

i: integer;

begin

for i := 1 to 3 do

begin

arr[i] := tau * lambda[i];

ser[i] := tau * mu[i];

walk[i] := tau * omega[i];

end;

totarr := arr[1] + arr[2] + arr[3];

end;

 

procedure HoldingRates;

 

var

i: integer;

begin

writeln('Enter the positive customer holding rate coefficient for each of the stations, beginning with station 1.');

writeln(fpout, 'Enter the positive customer holding rate coefficient for each of the stations, beginning with station 1.');

for i := 1 to 3 do

begin

read(HRate[i]);

writeln(fpout, HRate[i] : 15 : 6);

end;

end;

 

procedure WalkingCost;

 

var

i: integer;

begin

writeln('Enter the walking cost rate for each of the stations, beginning with station 1.');

writeln(fpout, 'Enter the walking cost rate for each of the stations, beginning with station 1.');

for i := 1 to 3 do

begin

read(WCost[i]);

writeln(fpout, WCost[i] : 15 : 6);

end;

end;

 

procedure Initial;

{This fills the arrays with zeros.}

{Fun is the u array when the server is stationary and Sun is the u array when it is walking . }

 

var

p, q, r, t: integer;

begin

for p := 0 to N do

for q := 0 to N do

for r := 0 to N do

for t := 1 to 3 do

begin

Fun[p, q, r, t] := 0;

Sun[p, q, r, t] := 0;

end;

end;

 

procedure CreateWFunandWSun;

{The WFun and WSun arrays are the w arrays.}

 

var

p, q, r, paux, qaux, raux, t, taux, a, b, c, bux: integer;

hold, Temp, TempNew: double;

Zed, Sed: RealListOne;

begin

for p := 0 to N do

for q := 0 to N do

for r := 0 to N do

begin

hold := p * HRate[1] + q * HRate[2] + r * HRate[3];

paux := p + 1;

qaux := q + 1;

raux := r + 1;

if p = N then

begin

paux := N;

end;

if q = N then

begin

qaux := N;

end;

if r = N then

begin

raux := N;

end;

for t := 1 to 3 do

begin

Zed[t] := arr[1] * Fun[paux, q, r, t] + arr[2] * Fun[p, qaux, r, t] + arr[3] * Fun[p, q, raux, t];

Sed[t] := arr[1] * Sun[paux, q, r, t] + arr[2] * Sun[p, qaux, r, t] + arr[3] * Sun[p, q, raux, t];

taux := t + 1;

if taux > 3 then

begin

taux := 1;

end;

WSun[p, q, r, t] := hold + Wcost[t] + Sed[t] + walk[t] * Fun[p, q, r, taux] + (1 - totarr - walk[t]) * Sun[p, q, r, t];

bux := 0;

a := p;

b := q;

c := r;

if (t = 1) and (p > 0) then

begin

a := p - 1;

bux := 1;

end;

if (t = 2) and (q > 0) then

begin

b := q - 1;

bux := 1;

end;

if (t = 3) and (r > 0) then

begin

c := r - 1;

bux := 1;

end;

Temp := Zed[t] + ser[t] * bux * Fun[a, b, c, t] + (1 - totarr - ser[t] * bux) * Fun[p, q, r, t];

OptAct[p, q, r, t] := 1;

TempNew := WCost[t] + Sed[t] + walk[t] * Fun[p, q, r, taux] + (1 - totarr - walk[t]) * Fun[p, q, r, t];

if TempNew < Temp then

begin

OptAct[p, q, r, t] := 0;

Temp := TempNew;

end;

WFun[p, q, r, t] := hold + Temp;

end;

end;

end;

 

procedure Update;

 

var

p, q, r, t: integer;

begin

for p := 0 to N do

for q := 0 to N do

for r := 0 to N do

for t := 1 to 3 do

begin

Fun[p, q, r, t] := WFun[p, q, r, t] - WFun[0, 0, 0, 1];

Sun[p, q, r, t] := WSun[p, q, r, t] - WFun[0, 0, 0, 1];

end;

end;

 

procedure WriteOptAct;

 

var

p, q, r, pbux, qbux, rbux, t: integer;

begin

writeln('The buffer occupancy vector is followed by the optimal choice at stations 1, 2, and 3.');

writeln(fpout, 'The buffer occupancy vector is followed by the optimal choice at stations 1, 2, and 3.');

writeln('A state is only printed if some action in that state does not follow the exhaustive policy.');

writeln(fpout, 'A state is only printed if some action in that state does not follow the exhaustive policy.');

writeln;

writeln(fpout);

for p := 0 to N do

for q := 0 to N do

for r := 0 to N do

begin

pbux := 1;

qbux := 1;

rbux := 1;

if p = 0 then

begin

pbux := 0;

end;

if q = 0 then

begin

qbux := 0;

end;

if r = 0 then

begin

rbux := 0;

end;

if (pbux <> OptAct[p, q, r, 1]) or (qbux <> OptAct[p, q, r, 2]) or (rbux <> OptAct[p, q, r, 3]) then

begin

writeln(p : S, q : S, r : S, 'act' : S, OptAct[p, q, r, 1] : S, OptAct[p, q, r, 2] : S, OptAct[p, q, r, 3] : S);

writeln(fpout, p : S, q : S, r : S, 'act' : S, OptAct[p, q, r, 1] : S, OptAct[p, q, r, 2] : S, OptAct[p, q, r, 3] : S);

end;

end;

end;

 

{Here is the main program.}

 

begin

writeln('Enter the run name.');

readln(file_name);

rewrite(fpout, file_name);

writeln(fpout, file_name);

 

writeln;

writeln(fpout);

 

writeln('The approximation level is', N);

writeln(fpout, 'The approximation level is', N);

 

ArrivalRates;

ServiceRates;

WalkingRates;

 

writeln('Enter the maximum value of the service and walking rates.');

readln(phi);

writeln(fpout, 'The maximum value of the service and walking rates is', phi);

 

tau := 0.5 / (lambda[1] + lambda[2] + lambda[3] + phi);

 

CreateQuantities;

HoldingRates;

WalkingCost;

 

writeln('Enter the tolerance. This is a small positive number.');

readln(epsilon);

writeln(fpout, 'The tolerance level is', epsilon);

 

writeln('Enter the maximum number of iterations allowed.');

readln(MAX);

writeln(fpout, 'The maximum number of iterations allowed is', MAX);

 

writeln;

writeln(fpout);

 

Initial;

 

S := 5;

Old := 1;

delta := 1;

I := 1;

 

 

while (delta > epsilon) and (I < MAX) do

begin

CreateWFunandWSun;

delta := abs(WFun[0, 0, 0, 1] - Old);

Old := WFun[0, 0, 0, 1];

Update;

I := I + 1;

end; {while}

 

writeln('The number of iterations is: ', I);

writeln(fpout, 'The number of iterations is: ', I);

 

writeln('The value of delta is: ', delta : 15 : 14);

writeln(fpout, 'The value of delta is: ', delta : 15 : 14);

 

writeln('The approximate average cost is:', WFun[0, 0, 0, 1] : 15 : 8);

writeln(fpout, 'The approximate average cost is:', WFun[0, 0, 0, 1] : 15 : 8);

 

writeln;

writeln(fpout);

 

WriteOptAct; {modified to also output to file}

close(fpout);

 

end.